import { wrap } from './matcher';
import { Query } from './query';
export { Query };
export interface IOptions {
    allowErrors?: boolean;
    usePathScoring?: boolean;
    useExtensionBonus?: boolean;
    pathSeparator?: "/" | "\\" | string;
    optCharRegEx?: RegExp;
    wrap?: {
        tagOpen?: string;
        tagClass?: string;
        tagClose?: string;
    };
    preparedQuery?: Query;
}
export interface IFilterOptions<T> extends IOptions {
    key?: T extends string ? never : keyof T;
    maxResults?: number;
    maxInners?: number;
}
export declare function filter<T>(candidates: T[], query: string, options?: IFilterOptions<T>): T[];
export declare function score(string: string, query: string, options?: IOptions): number;
export declare function match(string: string, query: string, options?: IOptions): number[];
export { wrap };
export declare function prepareQuery(query: string, options?: IOptions): Query;
